searchNodes=[{"doc":"Welcome to AshAuthentication.Pheonix . The ash_authentication_phoenix package extends ash_authentication by adding router helpers, plugs and behaviours that makes adding authentication to an existing Ash-based Phoenix application dead easy. Where to start. Presuming that you already have Phoenix , Ash and AshAuthentication installed and configured, start by adding plugs and routes to your router using AshAuthentication.Phoenix.Router and customising your sign-in page as needed. Customisation There are several methods of customisation available depending on the level of control you would like: Use the generic sign-in liveview - AshAuthentication.Phoenix.SignInLive . Apply overrides using AshAuthentication.Phoenix.Overrides to set your own CSS classes for all components. Build your own sign-in pages using the pre-defined components. Build your own sign-in pages using the generated auth routes.","ref":"AshAuthentication.Phoenix.html","title":"AshAuthentication.Phoenix","type":"module"},{"doc":"The authentication controller generator. Since authentication often requires explicit HTTP requests to do things like set cookies or return Authorization headers, use this module to create an AuthController in your Phoenix application. Example Handling the registration or authentication of a normal web-based user. defmodule MyAppWeb.AuthController do use MyAppWeb , :controller use AshAuthentication.Phoenix.Controller def success ( conn , _activity , user , _token ) do conn |&gt; store_in_session ( user ) |&gt; assign ( :current_user , user ) |&gt; redirect ( to : Routes . page_path ( conn , :index ) ) end def failure ( conn , _activity , _reason ) do conn |&gt; put_status ( 401 ) |&gt; render ( &quot;failure.html&quot; ) end def sign_out ( conn , _params ) do conn |&gt; clear_session ( ) |&gt; render ( &quot;sign_out.html&quot; ) end end Handling registration or authentication of an API user. defmodule MyAppWeb.ApiAuthController do use MyAppWeb , :controller use AshAuthentication.Phoenix.Controller alias AshAuthentication.TokenRevocation def success ( conn , _activity , _user , token ) do conn |&gt; put_status ( 200 ) |&gt; json ( %{ authentication : %{ status : :success , bearer : token } } ) end def failure ( conn , _activity , _reason ) do conn |&gt; put_status ( 401 ) |&gt; json ( %{ authentication : %{ status : :failed } } ) end def sign_out ( conn , _params ) do conn |&gt; revoke_bearer_tokens ( ) |&gt; json ( %{ status : :ok } ) end end","ref":"AshAuthentication.Phoenix.Controller.html","title":"AshAuthentication.Phoenix.Controller","type":"behaviour"},{"doc":"Called when authentication fails.","ref":"AshAuthentication.Phoenix.Controller.html#c:failure/3","title":"AshAuthentication.Phoenix.Controller.failure/3","type":"callback"},{"doc":"Called when a request to sign out is received.","ref":"AshAuthentication.Phoenix.Controller.html#c:sign_out/2","title":"AshAuthentication.Phoenix.Controller.sign_out/2","type":"callback"},{"doc":"Called when authentication (or registration, depending on the provider) has been successful.","ref":"AshAuthentication.Phoenix.Controller.html#c:success/4","title":"AshAuthentication.Phoenix.Controller.success/4","type":"callback"},{"doc":"","ref":"AshAuthentication.Phoenix.Controller.html#t:activity/0","title":"AshAuthentication.Phoenix.Controller.activity/0","type":"type"},{"doc":"","ref":"AshAuthentication.Phoenix.Controller.html#t:t/0","title":"AshAuthentication.Phoenix.Controller.t/0","type":"type"},{"doc":"","ref":"AshAuthentication.Phoenix.Controller.html#t:token/0","title":"AshAuthentication.Phoenix.Controller.token/0","type":"type"},{"doc":"","ref":"AshAuthentication.Phoenix.Controller.html#t:user/0","title":"AshAuthentication.Phoenix.Controller.user/0","type":"type"},{"doc":"Ensures that any loaded users which are present in a conn's assigns are also present in a live view socket's assigns. Typical usage is via the ash_authentication_live_session/2 macro, but can also manually called like so: scope &quot;/&quot; , ExampleWeb do pipe_through ( :browser ) live_session :authenticated , on_mount : LiveSession , session : { LiveSession , :generate_session , [ ] } do live &quot;/&quot; , ExampleLive end end","ref":"AshAuthentication.Phoenix.LiveSession.html","title":"AshAuthentication.Phoenix.LiveSession","type":"module"},{"doc":"Generate a live session wherein all subject assigns are copied from the conn into the socket. Options: :otp_app - Set the otp app in which to search for authenticated resources. All other options are passed through to live_session , but with session and on_mount hooks added to set assigns for authenticated resources.","ref":"AshAuthentication.Phoenix.LiveSession.html#ash_authentication_live_session/3","title":"AshAuthentication.Phoenix.LiveSession.ash_authentication_live_session/3","type":"macro"},{"doc":"Supplements the session with any current_X assigns which are authenticated resource records from the conn.","ref":"AshAuthentication.Phoenix.LiveSession.html#generate_session/2","title":"AshAuthentication.Phoenix.LiveSession.generate_session/2","type":"function"},{"doc":"Inspects the incoming session for any subject_name -&gt; subject values and loads them into the socket's assigns. For example a session containing {&quot;user&quot;, &quot;user?id=aa6c179c-ee75-4d49-8796-528c2981b396&quot;} becomes an assign called current_user with the loaded user as the value.","ref":"AshAuthentication.Phoenix.LiveSession.html#on_mount/4","title":"AshAuthentication.Phoenix.LiveSession.on_mount/4","type":"function"},{"doc":"Helper plugs mixed in to your router. When you use AshAuthentication.Phoenix.Router this module is included, so that you can use these plugs in your pipelines.","ref":"AshAuthentication.Phoenix.Plug.html","title":"AshAuthentication.Phoenix.Plug","type":"module"},{"doc":"Attempt to retrieve actors from the Authorization header(s). A wrapper around AshAuthentication.Plug.Helpers.retrieve_from_bearer/2 with the otp_app as extracted from the endpoint.","ref":"AshAuthentication.Phoenix.Plug.html#load_from_bearer/2","title":"AshAuthentication.Phoenix.Plug.load_from_bearer/2","type":"function"},{"doc":"Attempt to retrieve all actors from the connections' session. A wrapper around AshAuthentication.Plug.Helpers.retrieve_from_session/2 with the otp_app as extracted from the endpoint.","ref":"AshAuthentication.Phoenix.Plug.html#load_from_session/2","title":"AshAuthentication.Phoenix.Plug.load_from_session/2","type":"function"},{"doc":"Revoke all token(s) in the Authorization header(s). A wrapper around AshAuthentication.Plug.Helpers.revoke_bearer_tokens/2 with the otp_app as extracted from the endpoint.","ref":"AshAuthentication.Phoenix.Plug.html#revoke_bearer_tokens/2","title":"AshAuthentication.Phoenix.Plug.revoke_bearer_tokens/2","type":"function"},{"doc":"Store the actor in the connections' session.","ref":"AshAuthentication.Phoenix.Plug.html#store_in_session/2","title":"AshAuthentication.Phoenix.Plug.store_in_session/2","type":"function"},{"doc":"Phoenix route generation for AshAuthentication. Using this module imports the macros in this module and the plug functions from AshAuthentication.Phoenix.Plug . Usage Adding authentication to your live-view router is very simple: defmodule MyAppWeb.Router do use MyAppWeb , :router use AshAuthentication.Phoenix.Router pipeline :browser do # ... plug ( :load_from_session ) end pipeline :api do # ... plug ( :load_from_bearer ) end scope &quot;/&quot; , MyAppWeb do pipe_through :browser sign_in_route sign_out_route AuthController auth_routes_for MyApp.Accounts.User , to : AuthController reset_route end","ref":"AshAuthentication.Phoenix.Router.html","title":"AshAuthentication.Phoenix.Router","type":"module"},{"doc":"Generates the routes needed for the various strategies for a given AshAuthentication resource. This is required if you wish to use authentication. Options to - a module which implements the AshAuthentication.Phoenix.Controller behaviour. This is required. path - a string (starting with &quot;/&quot;) wherein to mount the generated routes. scope_opts - any options to pass to the generated scope. Example scope &quot;/&quot; , DevWeb do auth_routes_for ( MyApp.Accounts.User , to : AuthController , path : &quot;/authentication&quot; , scope_opts : [ host : &quot;auth.example.com&quot; ] ) end","ref":"AshAuthentication.Phoenix.Router.html#auth_routes_for/2","title":"AshAuthentication.Phoenix.Router.auth_routes_for/2","type":"macro"},{"doc":"Generates a generic, white-label password reset page using LiveView and the components in AshAuthentication.Phoenix.Components . Available options are: path the path under which to mount the live-view. Defaults to &quot;/password-reset&quot; . live_view the name of the live view to render. Defaults to AshAuthentication.Phoenix.ResetLive . as which is passed to the generated live route. Defaults to :auth . overrides specify any override modules for customisation. See AshAuthentication.Phoenix.Overrides for more information. all other options are passed to the generated scope . This is completely optional.","ref":"AshAuthentication.Phoenix.Router.html#reset_route/1","title":"AshAuthentication.Phoenix.Router.reset_route/1","type":"macro"},{"doc":"Generates a generic, white-label sign-in page using LiveView and the components in AshAuthentication.Phoenix.Components . This is completely optional. Available options are: path the path under which to mount the live-view. Defaults to &quot;/sign-in&quot; . live_view the name of the live view to render. Defaults to AshAuthentication.Phoenix.SignInLive . as which is passed to the generated live route. Defaults to :auth . otp_app the otp app or apps to find authentication resources in. Pulls from the socket by default. overrides specify any override modules for customisation. See AshAuthentication.Phoenix.Overrides for more information. all other options are passed to the generated scope .","ref":"AshAuthentication.Phoenix.Router.html#sign_in_route/1","title":"AshAuthentication.Phoenix.Router.sign_in_route/1","type":"macro"},{"doc":"Generates a sign-out route which points to the sign_out action in your auth controller. This is optional, but you probably want it.","ref":"AshAuthentication.Phoenix.Router.html#sign_out_route/3","title":"AshAuthentication.Phoenix.Router.sign_out_route/3","type":"macro"},{"doc":"Options that can be passed to auth_routes_for .","ref":"AshAuthentication.Phoenix.Router.html#t:auth_route_options/0","title":"AshAuthentication.Phoenix.Router.auth_route_options/0","type":"type"},{"doc":"A sub-path if required. Defaults to /auth .","ref":"AshAuthentication.Phoenix.Router.html#t:path_option/0","title":"AshAuthentication.Phoenix.Router.path_option/0","type":"type"},{"doc":"Any options which should be passed to the generated scope.","ref":"AshAuthentication.Phoenix.Router.html#t:scope_opts_option/0","title":"AshAuthentication.Phoenix.Router.scope_opts_option/0","type":"type"},{"doc":"The controller which will handle success and failure.","ref":"AshAuthentication.Phoenix.Router.html#t:to_option/0","title":"AshAuthentication.Phoenix.Router.to_option/0","type":"type"},{"doc":"Renders a very simple banner at the top of the sign-in component. Can show either an image or some text, depending on the provided overrides. Props overrides - A list of override modules. Overrides This component provides the following overrides: :dark_image_class - Css class for the img tag in dark mode. :dark_image_url - A URL for the img src attribute in dark mode. Set to nil to disable. :href_class - CSS class for the a tag. :href_url - A URL for the banner image to link to. Set to nil to disable. :image_class - CSS class for the img tag in dark mode. :image_url - A URL for the img src attribute. Set to nil to disable. :root_class - CSS class for the root div element. :text - Banner text. Set to nil to disable. :text_class - CSS class for the text div . See AshAuthentication.Phoenix.Overrides for more information.","ref":"AshAuthentication.Phoenix.Components.Banner.html","title":"AshAuthentication.Phoenix.Components.Banner","type":"module"},{"doc":"","ref":"AshAuthentication.Phoenix.Components.Banner.html#t:props/0","title":"AshAuthentication.Phoenix.Components.Banner.props/0","type":"type"},{"doc":"Helpers which are commonly needed inside the various components.","ref":"AshAuthentication.Phoenix.Components.Helpers.html","title":"AshAuthentication.Phoenix.Components.Helpers","type":"module"},{"doc":"The LiveView Socket contains a reference to the Phoenix endpoint, and from there we can extract the otp_app of the current request. This is pulled from assigns[:otp_app] , or inferred from the socket if that is not set.","ref":"AshAuthentication.Phoenix.Components.Helpers.html#otp_app_from_socket/1","title":"AshAuthentication.Phoenix.Components.Helpers.otp_app_from_socket/1","type":"function"},{"doc":"The LiveView Socket contains a refererence to the Phoenix router, and from there we can generate the name of the route helpers module.","ref":"AshAuthentication.Phoenix.Components.Helpers.html#route_helpers/1","title":"AshAuthentication.Phoenix.Components.Helpers.route_helpers/1","type":"function"},{"doc":"A horizontal rule with text. This component is pretty tailwind-specific, but I (@jimsynz) really wanted a certain look. If you think I'm wrong then please let me know. Overrides This component provides the following overrides: :hr_inner_class - CSS class for the inner div element of the horizontal rule. :hr_outer_class - CSS class for the outer div element of the horizontal rule. :root_class - CSS class for the root div element. :text - Text to display in front of the horizontal rule. :text_inner_class - CSS class for the inner div element of the text area. :text_outer_class - CSS class for the outer div element of the text area. See AshAuthentication.Phoenix.Overrides for more information. Props * ` overrides ` - A list of override modules .","ref":"AshAuthentication.Phoenix.Components.HorizontalRule.html","title":"AshAuthentication.Phoenix.Components.HorizontalRule","type":"module"},{"doc":"","ref":"AshAuthentication.Phoenix.Components.HorizontalRule.html#t:props/0","title":"AshAuthentication.Phoenix.Components.HorizontalRule.props/0","type":"type"},{"doc":"Generates a sign-in for for a resource using the &quot;Magic link&quot; strategy. Component hierarchy This is the top-most strategy-specific component, nested below AshAuthentication.Phoenix.Components.SignIn . Children: AshAuthentication.Phoenix.Components.Password.Input.identity_field/1 AshAuthentication.Phoenix.Components.Password.Input.submit/1 Props strategy - the strategy configuration as per AshAuthentication.Info.strategy/2 . Required. overrides - A list of override modules. Overrides This component provides the following overrides: :disable_button_text - Text for the submit button when the request is happening. :form_class - CSS class for the form element. :label_class - CSS class for the h2 element. :request_flash_text - Text for the flash message when a request is received. Set to nil to disable. :root_class - CSS class for the root div element. See AshAuthentication.Phoenix.Overrides for more information.","ref":"AshAuthentication.Phoenix.Components.MagicLink.html","title":"AshAuthentication.Phoenix.Components.MagicLink","type":"module"},{"doc":"","ref":"AshAuthentication.Phoenix.Components.MagicLink.html#t:props/0","title":"AshAuthentication.Phoenix.Components.MagicLink.props/0","type":"type"},{"doc":"Generates a sign-in button for OAuth2. Component hierarchy This is the top-most strategy-specific component, nested below AshAuthentication.Phoenix.Components.SignIn . Props strategy - The strategy configuration as per AshAuthentication.Info.strategy/2 . Required. overrides - A list of override modules. Overrides This component provides the following overrides: :icon_class - CSS classes for the icon SVG. :link_class - CSS classes for the a element. :root_class - CSS classes for the root div element. See AshAuthentication.Phoenix.Overrides for more information.","ref":"AshAuthentication.Phoenix.Components.OAuth2.html","title":"AshAuthentication.Phoenix.Components.OAuth2","type":"module"},{"doc":"","ref":"AshAuthentication.Phoenix.Components.OAuth2.html#icon/1","title":"AshAuthentication.Phoenix.Components.OAuth2.icon/1","type":"function"},{"doc":"","ref":"AshAuthentication.Phoenix.Components.OAuth2.html#t:props/0","title":"AshAuthentication.Phoenix.Components.OAuth2.props/0","type":"type"},{"doc":"Generates sign in, registration and reset forms for a resource. Component hierarchy This is the top-most strategy-specific component, nested below AshAuthentication.Phoenix.Components.SignIn . Children: AshAuthentication.Phoenix.Components.Password.SignInForm AshAuthentication.Phoenix.Components.Password.RegisterForm AshAuthentication.Phoenix.Components.Password.ResetForm Props strategy - The strategy configuration as per AshAuthentication.Info.strategy/2 . Required. overrides - A list of override modules. show_first - either :sign_in , :register or :reset which controls which form is visible on first load. Slots sign_in_extra - rendered inside the sign-in form with the form passed as a slot argument. register_extra - rendered inside the registration form with the form passed as a slot argument. reset_extra - rendered inside the reset form with the form passed as a slot argument. &lt;.live_component module={AshAuthentication.Phoenix.Components.Password} strategy={AshAuthentication.Info.strategy!(Example.User, :password)} id=&quot;user-with-password&quot; socket={@socket} overrides={[AshAuthentication.Phoenix.Overrides.Default]}&gt; &lt;:sign_in_extra :let={form}&gt; &lt;.input field={form[:capcha]} /&gt; &lt;/:sign_in_extra&gt; &lt;:register_extra :let={form}&gt; &lt;.input field={form[:name]} /&gt; &lt;/:register_extra&gt; &lt;:reset_extra :let={form}&gt; &lt;.input field={form[:capcha]} /&gt; &lt;/:reset_extra&gt; &lt;/.live_component&gt; Overrides This component provides the following overrides: :hide_class - CSS class to apply to hide an element. :interstitial_class - CSS class for the div element between the form and the button. :register_toggle_text - Toggle text to display when the register form is not showing (or nil to disable). :reset_toggle_text - Toggle text to display when the reset form is not showing (or nil to disable). :root_class - CSS class for the root div element. :show_first - The form to show on first load. Either :sign_in or :register . :sign_in_toggle_text - Toggle text to display when the sign in form is not showing (or nil to disable). :slot_class - CSS class for the div surrounding the slot. :toggler_class - CSS class for the toggler a element. See AshAuthentication.Phoenix.Overrides for more information.","ref":"AshAuthentication.Phoenix.Components.Password.html","title":"AshAuthentication.Phoenix.Components.Password","type":"module"},{"doc":"","ref":"AshAuthentication.Phoenix.Components.Password.html#t:props/0","title":"AshAuthentication.Phoenix.Components.Password.props/0","type":"type"},{"doc":"Function components for dealing with form input during password authentication. Component hierarchy These function components are consumed by AshAuthentication.Phoenix.Components.Password.SignInForm , AshAuthentication.Phoenix.Components.Password.RegisterForm and AshAuthentication.Phoenix.Components.ResetForm . Overrides This component provides the following overrides: :error_li - CSS class for the li elements on error lists. :error_ul - CSS class for the ul element on error lists. :field_class - CSS class for div elements surrounding the fields. :input_class - CSS class for text/password input elements. :input_class_with_error - CSS class for text/password input elements when there is a validation error. :input_debounce - Number of milliseconds to debounce input by (or nil to disable). :label_class - CSS class for label elements. :submit_class - CSS class for the form submit input element. See AshAuthentication.Phoenix.Overrides for more information.","ref":"AshAuthentication.Phoenix.Components.Password.Input.html","title":"AshAuthentication.Phoenix.Components.Password.Input","type":"module"},{"doc":"Generate a list of errors for a field (if there are any). Props socket - Phoenix LiveView socket. This is needed to be able to retrieve the correct CSS configuration. Required. form - An AshPhoenix.Form . Required. field - The field for which to retrieve the errors. Required. overrides - A list of override modules.","ref":"AshAuthentication.Phoenix.Components.Password.Input.html#error/1","title":"AshAuthentication.Phoenix.Components.Password.Input.error/1","type":"function"},{"doc":"Generate a form field for the configured identity field. Props socket - Phoenix LiveView socket. This is needed to be able to retrieve the correct CSS configuration. Required. strategy - The configuration map as per AshAuthentication.authenticated_resources/1 . Required. form - An AshPhoenix.Form . Required. input_type - Either :text or :email . If not set it will try and guess based on the name of the identity field. overrides - A list of override modules.","ref":"AshAuthentication.Phoenix.Components.Password.Input.html#identity_field/1","title":"AshAuthentication.Phoenix.Components.Password.Input.identity_field/1","type":"function"},{"doc":"Generate a form field for the configured password confirmation entry field. Props socket - Phoenix LiveView socket. This is needed to be able to retrieve the correct CSS configuration. Required. strategy - The configuration map as per AshAuthentication.authenticated_resources/1 . Required. form - An AshPhoenix.Form . Required. overrides - A list of override modules.","ref":"AshAuthentication.Phoenix.Components.Password.Input.html#password_confirmation_field/1","title":"AshAuthentication.Phoenix.Components.Password.Input.password_confirmation_field/1","type":"function"},{"doc":"Generate a form field for the configured password entry field. Props socket - Phoenix LiveView socket. This is needed to be able to retrieve the correct CSS configuration. Required. strategy - The configuration map as per AshAuthentication.authenticated_resources/1 . Required. form - An AshPhoenix.Form . Required. overrides - A list of override modules.","ref":"AshAuthentication.Phoenix.Components.Password.Input.html#password_field/1","title":"AshAuthentication.Phoenix.Components.Password.Input.password_field/1","type":"function"},{"doc":"Generate an form submit button. Props socket - Phoenix LiveView socket. This is needed to be able to retrieve the correct CSS configuration. Required. strategy - The configuration map as per AshAuthentication.authenticated_resources/1 . Required. form - An AshPhoenix.Form . Required. action - Either :sign_in or :register . Required. label - The text to show in the submit label. Generated from the configured action name (via Phoenix.HTML.Form.humanize/1 ) if not supplied. overrides - A list of override modules.","ref":"AshAuthentication.Phoenix.Components.Password.Input.html#submit/1","title":"AshAuthentication.Phoenix.Components.Password.Input.submit/1","type":"function"},{"doc":"Generates a default registration form. Component hierarchy This is a child of AshAuthentication.Phoenix.Components.Password . Children: AshAuthentication.Phoenix.Components.Password.Input.identity_field/1 AshAuthentication.Phoenix.Components.Password.Input.password_field/1 AshAuthentication.Phoenix.Components.Password.Input.password_confirmation_field/1 AshAuthentication.Phoenix.Components.Password.Input.submit/1 Props strategy - The strategy configuration as per AshAuthentication.Info.strategy/2 . Required. socket - Needed to infer the otp-app from the Phoenix endpoint. overrides - A list of override modules. Overrides This component provides the following overrides: :disable_button_text - Text for the submit button when the request is happening. :form_class - CSS class for the form element. :label_class - CSS class for the h2 element. :root_class - CSS class for the root div element. :slot_class - CSS class for the div surrounding the slot. See AshAuthentication.Phoenix.Overrides for more information.","ref":"AshAuthentication.Phoenix.Components.Password.RegisterForm.html","title":"AshAuthentication.Phoenix.Components.Password.RegisterForm","type":"module"},{"doc":"","ref":"AshAuthentication.Phoenix.Components.Password.RegisterForm.html#t:props/0","title":"AshAuthentication.Phoenix.Components.Password.RegisterForm.props/0","type":"type"},{"doc":"Generates a default password reset form. Component hierarchy This is a child of AshAuthentication.Phoenix.Components.Password . Children: AshAuthentication.Phoenix.Components.Password.Input.identity_field/1 AshAuthentication.Phoenix.Components.Password.Input.submit/1 Props strategy - The configuration map as per AshAuthentication.Info.strategy/2 . Required. label - The text to show in the submit label. Generated from the configured action name (via Phoenix.HTML.Form.humanize/1 ) if not supplied. Set to false to disable. overrides - A list of override modules. Overrides This component provides the following overrides: :disable_button_text - Text for the submit button when the request is happening. :form_class - CSS class for the form element. :label_class - CSS class for the h2 element. :reset_flash_text - Text for the flash message when a request is received. Set to nil to disable. :root_class - CSS class for the root div element. :slot_class - CSS class for the div surrounding the slot. See AshAuthentication.Phoenix.Overrides for more information.","ref":"AshAuthentication.Phoenix.Components.Password.ResetForm.html","title":"AshAuthentication.Phoenix.Components.Password.ResetForm","type":"module"},{"doc":"","ref":"AshAuthentication.Phoenix.Components.Password.ResetForm.html#t:props/0","title":"AshAuthentication.Phoenix.Components.Password.ResetForm.props/0","type":"type"},{"doc":"Generates a default sign in form. Component hierarchy This is a child of AshAuthentication.Phoenix.Components.Password . Children: AshAuthentication.Phoenix.Components.Password.Input.identity_field/1 AshAuthentication.Phoenix.Components.Password.Input.password_field/1 AshAuthentication.Phoenix.Components.Password.Input.submit/1 Props strategy - The configuration map as per AshAuthentication.Info.strategy/2 . Required. label - The text to show in the submit label. Generated from the configured action name (via Phoenix.HTML.Form.humanize/1 ) if not supplied. Set to false to disable. overrides - A list of override modules. Overrides This component provides the following overrides: :disable_button_text - Text for the submit button when the request is happening. :form_class - CSS class for the form element. :label_class - CSS class for the h2 element. :root_class - CSS class for the root div element. :slot_class - CSS class for the div surrounding the slot. See AshAuthentication.Phoenix.Overrides for more information.","ref":"AshAuthentication.Phoenix.Components.Password.SignInForm.html","title":"AshAuthentication.Phoenix.Components.Password.SignInForm","type":"module"},{"doc":"","ref":"AshAuthentication.Phoenix.Components.Password.SignInForm.html#t:props/0","title":"AshAuthentication.Phoenix.Components.Password.SignInForm.props/0","type":"type"},{"doc":"Renders a password-reset form. Component hierarchy Children: AshAuthentication.Phoenix.Components.Password.Input.password_field/1 AshAuthentication.Phoenix.Components.Password.Input.password_confirmation_field/1 AshAuthentication.Phoenix.Components.Password.Input.submit/1 Props token - The reset token. overrides - A list of override modules. otp_app - The otp app to look for authenticated resources in Overrides This component provides the following overrides: :root_class - CSS class for the root div element. :show_banner - Whether or not to show the banner. :strategy_class - CSS class for a div surrounding each strategy component. See AshAuthentication.Phoenix.Overrides for more information.","ref":"AshAuthentication.Phoenix.Components.Reset.html","title":"AshAuthentication.Phoenix.Components.Reset","type":"module"},{"doc":"","ref":"AshAuthentication.Phoenix.Components.Reset.html#t:props/0","title":"AshAuthentication.Phoenix.Components.Reset.props/0","type":"type"},{"doc":"Generates a default password reset form. Component hierarchy This is a child of AshAuthentication.Phoenix.Components.Reset . Children: AshAuthentication.Phoenix.Components.Password.Input.identity_field/1 AshAuthentication.Phoenix.Components.Password.Input.password_field/1 AshAuthentication.Phoenix.Components.Password.Input.submit/1 AshAuthentication.Phoenix.Components.Password.Input.error/1 Props token - The reset token. socket - Phoenix LiveView socket. This is needed to be able to retrieve the correct CSS configuration. Required. strategy - The configuration map as per AshAuthentication.Info.strategy/2 . Required. label - The text to show in the submit label. Generated from the configured action name (via Phoenix.HTML.Form.humanize/1 ) if not supplied. Set to false to disable. Overrides This component provides the following overrides: :disable_button_text - Text for the submit button when the request is happening. :form_class - CSS class for the form element. :label_class - CSS class for the h2 element. :root_class - CSS class for the root div element. :spacer_class - CSS classes for space between the password input and submit elements. See AshAuthentication.Phoenix.Overrides for more information.","ref":"AshAuthentication.Phoenix.Components.Reset.Form.html","title":"AshAuthentication.Phoenix.Components.Reset.Form","type":"module"},{"doc":"","ref":"AshAuthentication.Phoenix.Components.Reset.Form.html#t:props/0","title":"AshAuthentication.Phoenix.Components.Reset.Form.props/0","type":"type"},{"doc":"Renders sign in mark-up for an authenticated resource. This means that it will render sign-in UI for all of the authentication strategies for a resource. For each strategy configured on the resource a component name is inferred (e.g. AshAuthentication.Strategy.Password becomes AshAuthentication.Phoenix.Components.Password ) and is rendered into the output. Component hierarchy This is the top-most authentication component. Children: AshAuthentication.Phoenix.Components.Password . AshAuthentication.Phoenix.Components.OAuth2 . Overrides This component provides the following overrides: :root_class - CSS class for the root div element. :show_banner - Whether or not to show the banner. :strategy_class - CSS class for a div surrounding each strategy component. See AshAuthentication.Phoenix.Overrides for more information. Props overrides - A list of override modules. otp_app - The otp app to look for authenticated resources in","ref":"AshAuthentication.Phoenix.Components.SignIn.html","title":"AshAuthentication.Phoenix.Components.SignIn","type":"module"},{"doc":"","ref":"AshAuthentication.Phoenix.Components.SignIn.html#t:props/0","title":"AshAuthentication.Phoenix.Components.SignIn.props/0","type":"type"},{"doc":"Behaviour for overriding component styles and attributes in your application. The default implementation is AshAuthentication.Phoenix.Overrides.Default which uses TailwindCSS to generate a fairly generic looking user interface. You can override this by adding your own override modules to the AshAuthentication.Phoenix.Router.sign_in_route/1 macro in your router: sign_in_route overrides : [ MyAppWeb.AuthOverrides , AshAuthentication.Phoenix.Overrides.Default ] and defining lib/my_app_web/auth_overrides.ex within which you can set any overrides. The use macro defines overridable versions of all callbacks which return nil , so you only need to define the functions that you care about. Each of the override modules specified in the config will be called in the order that they're specified, so you can still use the defaults if you just override some properties. defmodule MyAppWeb.AuthOverrides do use AshAuthentication.Phoenix.Overrides alias AshAuthentication.Phoenix.Components override Components.Banner do set :image_url , &quot;/images/sign_in_logo.png&quot; end end","ref":"AshAuthentication.Phoenix.Overrides.html","title":"AshAuthentication.Phoenix.Overrides","type":"module"},{"doc":"Define overrides for a specific component.","ref":"AshAuthentication.Phoenix.Overrides.html#override/2","title":"AshAuthentication.Phoenix.Overrides.override/2","type":"macro"},{"doc":"Override a setting within a component.","ref":"AshAuthentication.Phoenix.Overrides.html#set/2","title":"AshAuthentication.Phoenix.Overrides.set/2","type":"macro"},{"doc":"This is the default overrides for our component UI. The CSS styles are based on TailwindCSS .","ref":"AshAuthentication.Phoenix.Overrides.Default.html","title":"AshAuthentication.Phoenix.Overrides.Default","type":"module"},{"doc":"","ref":"AshAuthentication.Phoenix.Overrides.Default.html#overrides/0","title":"AshAuthentication.Phoenix.Overrides.Default.overrides/0","type":"function"},{"doc":"Override introspection.","ref":"AshAuthentication.Phoenix.Overrides.Info.html","title":"AshAuthentication.Phoenix.Overrides.Info","type":"module"},{"doc":"Returns a map of all known overridable modules and their overrides.","ref":"AshAuthentication.Phoenix.Overrides.Info.html#all_overridable_modules/0","title":"AshAuthentication.Phoenix.Overrides.Info.all_overridable_modules/0","type":"function"},{"doc":"Auto generates documentation and helpers for components.","ref":"AshAuthentication.Phoenix.Overrides.Overridable.html","title":"AshAuthentication.Phoenix.Overrides.Overridable","type":"behaviour"},{"doc":"","ref":"AshAuthentication.Phoenix.Overrides.Overridable.html#c:__overrides__/0","title":"AshAuthentication.Phoenix.Overrides.Overridable.__overrides__/0","type":"callback"},{"doc":"Retrieve configuration for a potentially overriden value.","ref":"AshAuthentication.Phoenix.Overrides.Overridable.html#override_for/3","title":"AshAuthentication.Phoenix.Overrides.Overridable.override_for/3","type":"macro"},{"doc":"A generic, white-label password reset page. This live-view can be rendered into your app using the AshAuthentication.Phoenix.Router.reset_route/1 macro in your router (or by using Phoenix.LiveView.Controller.live_render/3 directly in your markup). This live-view looks for the token URL parameter, and if found passes it to AshAuthentication.Phoenix.Components.Reset . Overrides This component provides the following overrides: :reset_id - Element ID for the Reset LiveComponent. :root_class - CSS class for the root div element. See AshAuthentication.Phoenix.Overrides for more information.","ref":"AshAuthentication.Phoenix.ResetLive.html","title":"AshAuthentication.Phoenix.ResetLive","type":"module"},{"doc":"A generic, white-label sign-in page. This live-view can be rendered into your app using the AshAuthentication.Phoenix.Router.sign_in_route/1 macro in your router (or by using Phoenix.LiveView.Controller.live_render/3 directly in your markup). This live-view finds all Ash resources with an authentication configuration (via AshAuthentication.authenticated_resources/1 ) and renders the appropriate UI for their providers using AshAuthentication.Phoenix.Components.SignIn . Overrides This component provides the following overrides: :root_class - CSS class for the root div element. :sign_in_id - Element ID for the SignIn LiveComponent. See AshAuthentication.Phoenix.Overrides for more information.","ref":"AshAuthentication.Phoenix.SignInLive.html","title":"AshAuthentication.Phoenix.SignInLive","type":"module"},{"doc":"The ash_authentication_phoenix package extends ash_authentication by adding router helpers, plugs and behaviours that makes adding authentication to an existing Ash-based Phoenix application dead easy.","ref":"readme.html","title":"Read Me","type":"extras"},{"doc":"See the official documentation for more. Additionally, documentation for the latest release will be available on hexdocs and for the main branch .","ref":"readme.html#documentation","title":"Read Me - Documentation","type":"extras"},{"doc":"To contribute updates, fixes or new features please fork and open a pull-request against main . Please use conventional commits - this allows us to dynamically generate the changelog. Feel free to ask any questions on out GitHub discussions page .","ref":"readme.html#contributing","title":"Read Me - Contributing","type":"extras"},{"doc":"MIT","ref":"readme.html#license","title":"Read Me - License","type":"extras"},{"doc":"In this step-by-step tutorial we create a new empty Example Phoenix + Ash application which provides the functionality for authentication. For beginners it is the best to follow the tutorial in the given order. For more advanced users it is a good reference to pick and choose from. We assumes that you have Elixir version 1.14.x (check with elixir -v ) and Phoenix 1.7 (check with mix phx.new --version ) installed. We also assume that you have a PostgreSQL database running which we use to persist the user data.","ref":"getting-started-with-ash-authentication-phoenix.html","title":"Getting Started Ash Authentication Phoenix","type":"extras"},{"doc":"We start with a new Phoenix application: $ mix phx.new example $ cd example","ref":"getting-started-with-ash-authentication-phoenix.html#green-field-phoenix-application","title":"Getting Started Ash Authentication Phoenix - Green Field Phoenix Application","type":"extras"},{"doc":"Application Dependencies We need to add the following dependencies. Use mix hex.info dependency_name to get the latest version of each dependency. mix.exs defmodule Example.MixProject do use Mix.Project # ... defp deps do [ # ... # add these lines --&gt; { :ash , &quot;~&gt; x.x&quot; } , { :ash_authentication , &quot;~&gt; x.x&quot; } , { :ash_authentication_phoenix , &quot;~&gt; x.x&quot; } , { :ash_postgres , &quot;~&gt; x.x&quot; } # &lt;-- add these lines ] end # ... Let's fetch everything: $ mix deps.get Formatter We can make our life easier and the code more consistent by adding formatters to the project. We will use Elixir's built-in formatter for this. .formatter.exs [ import_deps : [ :phoenix , # add these lines --&gt; :ash , :ash_authentication_phoenix , :ash_postgres # &lt;-- add these lines ] , plugins : [ Phoenix.LiveView.HTMLFormatter ] , inputs : [ &quot;*.{heex,ex,exs}&quot; , &quot;{config,lib,test}/**/*.{heex,ex,exs}&quot; ] ] Phoenix 1.7 compatibility For Phoenix 1.7 we need to change helpers: false to helpers: true in the router section: lib/example_web.ex defmodule ExampleWeb do # ... def router do quote do use Phoenix.Router , helpers : true # &lt;-- Change this line # ... Tailwind If you plan on using our default Tailwind -based components without overriding them you will need to modify your assets/tailwind.config.js to include the ash_authentication_phoenix dependency: assets/tailwind.config.js // See the Tailwind configuration guide for advanced usage // https://tailwindcss.com/docs/configuration const plugin = require(&quot;tailwindcss/plugin&quot;) module.exports = { content: [ &quot;./js/**/*.js&quot;, &quot;../lib/*_web.ex&quot;, &quot;../lib/*_web/**/*.*ex&quot;, &quot;../deps/ash_authentication_phoenix/**/*.ex&quot; // &lt;-- Add this line ], theme: { extend: { colors: { brand: &quot;#FD4F00&quot;, } }, }, plugins: [ require(&quot;@tailwindcss/forms&quot;), plugin(({ addVariant }) =&gt; addVariant(&quot;phx-no-feedback&quot;, [&quot;.phx-no-feedback&amp;&quot;, &quot;.phx-no-feedback &amp;&quot;])), plugin(({ addVariant }) =&gt; addVariant(&quot;phx-click-loading&quot;, [&quot;.phx-click-loading&amp;&quot;, &quot;.phx-click-loading &amp;&quot;])), plugin(({ addVariant }) =&gt; addVariant(&quot;phx-submit-loading&quot;, [&quot;.phx-submit-loading&amp;&quot;, &quot;.phx-submit-loading &amp;&quot;])), plugin(({ addVariant }) =&gt; addVariant(&quot;phx-change-loading&quot;, [&quot;.phx-change-loading&amp;&quot;, &quot;.phx-change-loading &amp;&quot;])) ] }","ref":"getting-started-with-ash-authentication-phoenix.html#basic-ash-setup","title":"Getting Started Ash Authentication Phoenix - Basic Ash Setup","type":"extras"},{"doc":"We use AshPostgres to handle the database tables for our application. We need to replace the content of the Repo module with the following code: lib/example/repo.ex defmodule Example.Repo do use AshPostgres.Repo , otp_app : :example def installed_extensions do [ &quot;uuid-ossp&quot; , &quot;citext&quot; ] end end We have to configure the Repo in config/config.exs . While doing that we also configure other stuff which we need later. config/config.exs # ... import Config # add these lines --&gt; config :example , ash_apis : [ Example.Accounts ] config :ash , :use_all_identities_in_manage_relationship? , false # &lt;-- add these lines # ... We need to add AshAuthentication.Supervisor to the supervision tree in lib/example/application.ex : ** lib/example/application.ex ** defmodule Example.Application do # ... @impl true def start ( _type , _args ) do children = [ # ... # add this line --&gt; { AshAuthentication.Supervisor , otp_app : :example } # &lt;-- add this line ] # ...","ref":"getting-started-with-ash-authentication-phoenix.html#ashpostgres-repo-setup","title":"Getting Started Ash Authentication Phoenix - AshPostgres.Repo Setup","type":"extras"},{"doc":"We need to create an Accounts Api in our application to provide a User and a Token resource. Strictly speaking we don't need the Token resource for just the login with a password. But we'll need it later (e.g. for the password reset) so we just create it now while we are here. At the end we should have the following directory structure: lib/example ├── accounts | ├── accounts.ex | └── resources │   ├── registry.ex │   ├── token.ex |   └── user.ex ... lib/example/accounts/accounts.ex defmodule Example.Accounts do use Ash.Api resources do registry Example.Accounts.Registry end end lib/example/accounts/resources/user.ex defmodule Example.Accounts.User do use Ash.Resource , data_layer : AshPostgres.DataLayer , extensions : [ AshAuthentication ] attributes do uuid_primary_key :id attribute :email , :ci_string , allow_nil? : false attribute :hashed_password , :string , allow_nil? : false , sensitive? : true end authentication do api Example.Accounts strategies do password :password do identity_field ( :email ) end end tokens do enabled? ( true ) token_resource ( Example.Accounts.Token ) signing_secret ( Application . compile_env ( :example , ExampleWeb.Endpoint ) [ :secret_key_base ] ) end end postgres do table &quot;users&quot; repo Example.Repo end identities do identity :unique_email , [ :email ] end # If using policies, add the following bypass: # policies do # bypass AshAuthentication.Checks.AshAuthenticationInteraction do # authorize_if always() # end # end end lib/example/accounts/resources/token.ex defmodule Example.Accounts.Token do use Ash.Resource , data_layer : AshPostgres.DataLayer , extensions : [ AshAuthentication.TokenResource ] token do api Example.Accounts end postgres do table &quot;tokens&quot; repo Example.Repo end # If using policies, add the following bypass: # policies do # bypass AshAuthentication.Checks.AshAuthenticationInteraction do # authorize_if always() # end # end end Next, let's define our registry: lib/example/accounts/registry.ex defmodule Example.Accounts.Registry do use Ash.Registry , extensions : [ Ash.Registry.ResourceValidations ] entries do entry Example.Accounts.User entry Example.Accounts.Token end end Create and Migration Now is a good time to create the database and run the migrations. You have to use specific ash_postgres mix tasks for that: $ mix ash_postgres.create $ mix ash_postgres.generate_migrations --name add_user_and_token $ mix ash_postgres.migrate In case you want to drop the database and start over again during development you can use mix ash_postgres.drop followed by mix ash_postgres.create and mix ash_postgres.migrate .","ref":"getting-started-with-ash-authentication-phoenix.html#accounts-api-and-resources","title":"Getting Started Ash Authentication Phoenix - Accounts Api and Resources","type":"extras"},{"doc":"ash_authentication_phoenix includes several helper macros which can generate Phoenix routes for you. For that you need to add 6 lines in the router module or just replace the whole file with the following code: lib/example_web/router.ex defmodule ExampleWeb.Router do use ExampleWeb , :router # Add this line use AshAuthentication.Phoenix.Router pipeline :browser do plug :accepts , [ &quot;html&quot; ] plug :fetch_session plug :fetch_live_flash plug :put_root_layout , { ExampleWeb.Layouts , :root } plug :protect_from_forgery plug :put_secure_browser_headers # Add the next line plug :load_from_session end pipeline :api do plug :accepts , [ &quot;json&quot; ] # Add the next line plug :load_from_bearer end scope &quot;/&quot; , ExampleWeb do pipe_through :browser get &quot;/&quot; , PageController , :home # add these lines --&gt; sign_in_route ( ) sign_out_route AuthController auth_routes_for Example.Accounts.User , to : AuthController reset_route [ ] # &lt;-- add these lines end # Other scopes may use custom stacks. # scope &quot;/api&quot;, ExampleWeb do # pipe_through :api # end # Enable LiveDashboard and Swoosh mailbox preview in development if Application . compile_env ( :example , :dev_routes ) do # If you want to use the LiveDashboard in production, you should put # it behind authentication and allow only admins to access it. # If your application does not have an admins-only section yet, # you can use Plug.BasicAuth to set up some basic authentication # as long as you are also using SSL (which you should anyway). import Phoenix.LiveDashboard.Router scope &quot;/dev&quot; do pipe_through :browser live_dashboard &quot;/dashboard&quot; , metrics : ExampleWeb.Telemetry forward &quot;/mailbox&quot; , Plug.Swoosh.MailboxPreview end end end Generated routes Given the above configuration you should see the following in your routes: # mix phx.routes Generated example app auth_path GET / sign - in AshAuthentication.Phoenix.SignInLive :sign_in auth_path GET / sign - out ExampleWeb.AuthController :sign_out auth_path * / auth / user / password / register ExampleWeb.AuthController { :user , :password , :register } auth_path * / auth / user / password / sign_in ExampleWeb.AuthController { :user , :password , :sign_in } page_path GET / ExampleWeb.PageController :home ...","ref":"getting-started-with-ash-authentication-phoenix.html#router-setup","title":"Getting Started Ash Authentication Phoenix - Router Setup","type":"extras"},{"doc":"While running mix phx.routes you probably saw the warning message that the ExampleWeb.AuthController.init/1 is undefined . Let's fix that by creating a new controller: lib/my_app_web/controllers/auth_controller.ex defmodule ExampleWeb.AuthController do use ExampleWeb , :controller use AshAuthentication.Phoenix.Controller def success ( conn , _activity , user , _token ) do return_to = get_session ( conn , :return_to ) || ~p&quot;/&quot; conn |&gt; delete_session ( :return_to ) |&gt; store_in_session ( user ) |&gt; assign ( :current_user , user ) |&gt; redirect ( to : return_to ) end def failure ( conn , _activity , _reason ) do conn |&gt; put_status ( 401 ) |&gt; render ( &quot;failure.html&quot; ) end def sign_out ( conn , _params ) do return_to = get_session ( conn , :return_to ) || ~p&quot;/&quot; conn |&gt; clear_session ( ) |&gt; redirect ( to : return_to ) end end lib/example_web/controllers/auth_html.ex defmodule ExampleWeb.AuthHTML do use ExampleWeb , :html embed_templates &quot;auth_html/*&quot; end lib/example_web/controllers/auth_html/failure.html.heex &lt;h1 class=&quot;text-2xl&quot;&gt;Authentication Error&lt;/h1&gt;","ref":"getting-started-with-ash-authentication-phoenix.html#authcontroller","title":"Getting Started Ash Authentication Phoenix - AuthController","type":"extras"},{"doc":"To see how the authentication works we replace the default Phoenix home.html.eex with a minimal example which has a top navbar. On the right side it shows the @current_user and a sign out button. If you are not signed in you will see a sign in button. lib/example_web/controllers/page_html/home.html.heex &lt;nav class=&quot;bg-gray-800&quot;&gt; &lt;div class=&quot;px-2 mx-auto max-w-7xl sm:px-6 lg:px-8&quot;&gt; &lt;div class=&quot;relative flex items-center justify-between h-16&quot;&gt; &lt;div class=&quot;flex items-center justify-center flex-1 sm:items-stretch sm:justify-start&quot;&gt; &lt;div class=&quot;block ml-6&quot;&gt; &lt;div class=&quot;flex space-x-4&quot;&gt; &lt;div class=&quot;px-3 py-2 text-xl font-medium text-white &quot;&gt; Ash Demo &lt;/div&gt; &lt;/div&gt; &lt;/div&gt; &lt;/div&gt; &lt;div class=&quot;absolute inset-y-0 right-0 flex items-center pr-2 sm:static sm:inset-auto sm:ml-6 sm:pr-0&quot;&gt; &lt;%= if @current_user do %&gt; &lt;span class=&quot;px-3 py-2 text-sm font-medium text-white rounded-md&quot;&gt; &lt;%= @current_user.email %&gt; &lt;/span&gt; &lt;a href=&quot;/sign-out&quot; class=&quot;rounded-lg bg-zinc-100 px-2 py-1 text-[0.8125rem] font-semibold leading-6 text-zinc-900 hover:bg-zinc-200/80 active:text-zinc-900/70&quot; &gt; Sign out &lt;/a&gt; &lt;% else %&gt; &lt;a href=&quot;/sign-in&quot; class=&quot;rounded-lg bg-zinc-100 px-2 py-1 text-[0.8125rem] font-semibold leading-6 text-zinc-900 hover:bg-zinc-200/80 active:text-zinc-900/70&quot; &gt; Sign In &lt;/a&gt; &lt;% end %&gt; &lt;/div&gt; &lt;/div&gt; &lt;/div&gt; &lt;/nav&gt; &lt;div class=&quot;py-10&quot;&gt; &lt;header&gt; &lt;div class=&quot;px-4 mx-auto max-w-7xl sm:px-6 lg:px-8&quot;&gt; &lt;h1 class=&quot;text-3xl font-bold leading-tight tracking-tight text-gray-900&quot;&gt;Demo&lt;/h1&gt; &lt;/div&gt; &lt;/header&gt; &lt;main&gt; &lt;div class=&quot;mx-auto max-w-7xl sm:px-6 lg:px-8&quot;&gt; &lt;div class=&quot;px-4 py-8 sm:px-0&quot;&gt; &lt;div class=&quot;border-4 border-gray-200 border-dashed rounded-lg h-96&quot;&gt;&lt;/div&gt; &lt;/div&gt; &lt;/div&gt; &lt;/main&gt; &lt;/div&gt; Start Phoenix You can now start Phoenix and visit localhost:4000 from your browser. $ mix phx.server Sign In Visit localhost:4000/sign-in from your browser. The sign in page shows a link to register a new account. Sign Out Visit localhost:4000/sign-out from your browser.","ref":"getting-started-with-ash-authentication-phoenix.html#example-home-html-heex","title":"Getting Started Ash Authentication Phoenix - Example home.html.heex","type":"extras"},{"doc":"In this section we add a reset password functionality. Which is triggered by adding resettable in the User resource. Please replace the strategies block in lib/example/accounts/resources/user.ex with the following code: lib/example/accounts/resources/user.ex # [...] strategies do password :password do identity_field ( :unique_email ) resettable do sender ( Example.Accounts.User.Senders.SendPasswordResetEmail ) end end end # [...] To make this work we need to create a new module Example.Accounts.User.Senders.SendPasswordResetEmail : lib/example/accounts/user/senders/send_password_reset_email.ex defmodule Example.Accounts.User.Senders.SendPasswordResetEmail do @moduledoc &quot;&quot;&quot; Sends a password reset email &quot;&quot;&quot; use AshAuthentication.Sender use ExampleWeb , :verified_routes @impl AshAuthentication.Sender def send ( user , token , _ ) do Example.Accounts.Emails . deliver_reset_password_instructions ( user , url ( ~p&quot;/password-reset/ \#{ token } &quot; ) ) end end We also need to create a new email template: lib/example/accounts/emails.ex defmodule Example.Accounts.Emails do @moduledoc &quot;&quot;&quot; Delivers emails. &quot;&quot;&quot; import Swoosh.Email def deliver_reset_password_instructions ( user , url ) do if ! url do raise &quot;Cannot deliver reset instructions without a url&quot; end deliver ( user . email , &quot;Reset Your Password&quot; , &quot;&quot;&quot; &lt;html&gt; &lt;p&gt; Hi \#{ user . email } , &lt;/p&gt; &lt;p&gt; &lt;a href=&quot; \#{ url } &quot;&gt;Click here&lt;/a&gt; to reset your password. &lt;/p&gt; &lt;p&gt; If you didn&#39;t request this change, please ignore this. &lt;/p&gt; &lt;html&gt; &quot;&quot;&quot; ) end # For simplicity, this module simply logs messages to the terminal. # You should replace it by a proper email or notification tool, such as: # # * Swoosh - https://hexdocs.pm/swoosh # * Bamboo - https://hexdocs.pm/bamboo # defp deliver ( to , subject , body ) do IO . puts ( &quot;Sending email to \#{ to } with subject \#{ subject } and body \#{ body } &quot; ) new ( ) |&gt; from ( { &quot;Zach&quot; , &quot;zach@ash-hq.org&quot; } ) # TODO: Replace with your email |&gt; to ( to_string ( to ) ) |&gt; subject ( subject ) |&gt; put_provider_option ( :track_links , &quot;None&quot; ) |&gt; html_body ( body ) |&gt; Example.Mailer . deliver! ( ) end end Your new reset password functionality is active. Visit localhost:4000/sign-in with your browser and click on the Forgot your password? link to trigger the reset password workflow.","ref":"getting-started-with-ash-authentication-phoenix.html#reset-password","title":"Getting Started Ash Authentication Phoenix - Reset Password","type":"extras"}]